Subject: [SUA issue 15]: Segmentation/Reassembly/Sequencing (Part II)

From: [email-masked]
Date: Thu, 6 Sep 2001 11:17:51 +0300

Hi,

Dealing with Part II:

> > Subissue 2: Should ASP be allowed to segment CLDT messages 
> > that it sends to SG.
> > 
> > Add text to 4.1 to state:
> > 
> > ASPs may segment CLDT messages, based upon knowledge of 
> > segmentation size supported at the SG(s) to which the ASP 
> > has routes to.
> > 
> > Sandeep >> I do not think this issue was fully resolved.
> > 
> > >> Benefits
> > It may be useful for multiple SG case and for the case when 
> > ASP feels segmentation may not be supported by SG.
> > 
> > >> Issues
> > How segmentation at ASP will be useful for avoiding 
> > segmentation disruption in multiple SG case need to be further
> > explored?
> > As ASP may not have idea of segment size to be used by SCCP 
> > so it may involve first a reassembly and then as re-segmentation 
> > at SG.
> > 
> > My view is segmentation at ASP will not be that useful and 
> > can be avoided.
> 
> There is certainly no reason to stop an implementation from segmenting
> at the ASP if it is capable of doing so.  I always segment at the ASP,
> because it is the only way to ensure that segmentation 
> disruptions will not occur.  It is a whole 10 lines of code.  All 
> that is required in the draft is a "MAY".

So, I propose that section 4.1 state the following:

4.1 SCCP - SUA Interworking at the SG

On the SG, the SCCP routing or interworking function determines that the
message is sent to an AS via the SUA stack, based on information in the
incoming message. The SUA Address Mapping Function identifies the
appropriate Application Server (AS) and selects an active ASP from the list
of ASPs servicing this AS. The appropriate ASP can be determined based on
the routing information in the incoming message, local load sharing
information, etc. The appropriate SUA message is then constructed and sent
to the appropriate endpoint, via the correct SCTP association and stream.

The SGP SHOULD take care of any segmentation / reassembly issues at the
border of the SS7 and IP networks.  The ASP may not have any knowledge about
the requirements regarding the maximum supported message length of the SS7
network to which it is sending. However, since there is in principle no
limit to the use of the more indicator in SS7 networks, there is still a
need for connection-oriented segmentation / reassembly procedures in the ASP
as well. 

Additionally, ASPs MAY segment CLDT messages, based upon knowledge of
segmentation size supported at the SG(s) to which the ASP has routes to.

Comments?

John

---
You are currently subscribed to sigtran as: [email-masked]
To unsubscribe send a blank email to [email-masked]

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Thu, 6 Sep 2001 05:10:14 -0500

John,

> 4.1 SCCP - SUA Interworking at the SG
[snip]
> border of the SS7 and IP networks.

The above statement is mostly incorrect.

The SGP SHOULD NOT attempt to reassemble DT1/DT2 as it has no
knowledge of when the stream might end.  The ASP SHOULD be
responsible for reassembly of CODT.

The SGP SHOULD NOT attempt to reassemble XL/UDT when it is
acting as an SG/STP.  The ASP SHOULD perform reassembly of
XL/UDT in this situation.

The SGP SHOULD NOT attempt to segment CODT into DT, particularly
for class 3.

The ASP SHOULD be responsible for segmenting data into CODT of
the appropriate size for DT1/DT2.

The only thing that the SGP should do is:

The SGP SHOULD segment CLDT into XL/UDT.  However, if the SG is
acting as an STP, the ASP SHOULD include the Segmentation
parameter and the ASP MAY segment CLDT.

> The ASP may not have any knowledge about the requirements regarding the
> maximum supported message length of the SS7 network to which it is sending.

This statement is misleading.  DT1/DT2 have clear size
limitations.  So does (XL)UDTS.  This is no different than the
case for M3UA.  Actually, the ASP has plenty of knowledge in
this regard.

> However, since there is in principle no limit to the use of the more
> indicator in SS7 networks, there is still a need for connection-oriented
> segmentation / reassembly procedures in the ASP as well. 

Again, misleading.  The only place that CO
segmentation/reassembly should be performed is at the ASP.

> segmentation size supported at the SG(s) to which the ASP has routes to.

The above statement is ok.

--brian

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---

---

From: [email-masked]
Date: Thu, 6 Sep 2001 13:31:01 +0300

Brian,

Is this better:

John

4.1.1 Connectionless Data

4.1.2 Connection-Oriented Data

The SGP SHOULD NOT attempt to segment CODT into DT, particularly
for class 3. The ASP performs reassembly of CODT messages. The ASP SHOULD be
responsible for segmenting data into CODT of
the appropriate size for DT1/DT2.

---

---

From: [email-masked]
Date: Thu, 6 Sep 2001 16:07:36 +0530

Hi ,

Copying some text from other thread on the issue of allowing segmentation of
CLDT messages at  ASP.

> Sandeep >> Can you please explain segmentation disruption scenario you have in
> mind that can be avoided if segmentation is done at ASP and would have caused
> problems if no segmentation was done?

Pardon, I was thinking reassembly (which requires the same paramter).

Brian , IMO during your discussion with Gery avoidance of disruption of traffic
in multiple SG case was considered primary reason for allowing ASP to perform
segmentation of CLDT messages.  Are there any other cases where ASP may find it
useful to perform segmentation ?
In my  view SCTP does a good job of segmentation/reassembly and SCTP application
(SUA ) should do segmentation only when there is a good reason for doing it.
MTP3 does not provide that service to SCCP , So what applies to SCCP does not
apply to SUA directly.

Best Regards,
-Sandeep

[email-masked] on 09/06/2001 02:47:51 PM

Please respond to [email-masked]

To:   "sigtran" <[email-masked]>
cc:   [email-masked] (bcc: Sandeep Mahajan/HSS)

Subject:  [SUA issue 15]: Segmentation/Reassembly/Sequencing (Part II)

Hi,

Comments?

John

---
You are currently subscribed to sigtran as: [email-masked]
To unsubscribe send a blank email to
[email-masked]

---

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Thu, 6 Sep 2001 06:02:04 -0500

John,

Just add the IPSP cases in...

> segmentation size supported at the SG(s) to which the ASP has routes to.

The IPSP SHOULD NOT segment N-UNITDATA into CLDT.

> the appropriate size for DT1/DT2.

The IPSP SHOULD NOT attempt to resegment, or reassemble, into CODT
data received from the local user in a N-DATA request primitive.

The IPSP SHOULD be responsible for any resegmentation or reassembly
which is required to indicate data received in CODT messages to the
local user in N-DATA indication primitives.

--brian

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Thu, 6 Sep 2001 06:11:13 -0500

Sandeep,

> useful to perform segmentation ?

Yes, for implementation reasons.  Thus the MAY.

> (SUA ) should do segmentation only when there is a good reason for doing it.

SCTP does not necessarily do a good job of segmentation/reassembly in all
implementations.  Different implementations might have different costs.

Remember that TCAP performs its own segmentation/reassembly.  There are
probably no cases where CLDT will require segmentation anyway.

> MTP3 does not provide that service to SCCP , So what applies to SCCP does not

What is your point here?

--brian

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---

---

From: [email-masked]
Date: Thu, 6 Sep 2001 14:39:05 +0300

Brian & Sandeep,

Is this OK?

 

The SGP SHOULD NOT attempt to segment CODT into DT, particularly
for class 3. The ASP performs reassembly of CODT messages. The ASP 
SHOULD be responsible for segmenting data into CODT of the appropriate 
size for DT1/DT2.

---

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Thu, 6 Sep 2001 06:55:42 -0500

John,

Works for me.

--brian

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---

---

From: [email-masked]
Date: Thu, 6 Sep 2001 19:45:11 +0530

Brian,

Again can you please share the possible list of implementation reasons, because
of which an implementation at ASP MAY segment CLDT message? I am concerned
because putting a MAY will require that SUA at SG MUST be prepared to support
reassembly of CLDT messages, which I think should be avoided.

Best Regards,
-Sandeep

"Brian F. G. Bidulock" <[email-masked]> on 09/06/2001 05:41:13 PM

To:   "sigtran" <[email-masked]>
cc:    (bcc: Sandeep Mahajan/HSS)

Subject:  Re: [SUA issue 15]: Segmentation/Reassembly/Sequencing (Part II)

Sandeep,

What is your point here?

--brian

--
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---

---

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Thu, 6 Sep 2001 13:19:32 -0500

Sandeep,

> reassembly of CLDT messages, which I think should be avoided.

One MAY does not imply another MUST.

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---

---

From: [email-masked]
Date: Fri, 7 Sep 2001 13:39:44 +0530

Brian , John ,

Comments below ..

"Brian F. G. Bidulock" <[email-masked]> on 09/07/2001 12:49:32 AM

Sandeep,

Sandeep >> It does according to RFC 2119. Please see the following text from
section 5 of RFC 2119.
MAY   This word, or the adjective "OPTIONAL", mean that an item is
   truly optional.  One vendor may choose to include the item because a
   particular marketplace requires it or because the vendor feels that
   it enhances the product while another vendor may omit the same item.
   An implementation which does not include a particular option MUST be
   prepared to interoperate with another implementation which does
   include the option, though perhaps with reduced functionality. In the
   same vein an implementation which does include a particular option
   MUST be prepared to interoperate with another implementation which
   does not include the option (except, of course, for the feature the
   option provides.)

Now you are saying SUA at ASP can segment CLDT message and SUA at SG need not
support reassembly. How should SUA at SG should handle these segmented messages?
Should SUA just pass these segmented messages to SCCP and SCCP sends them
further in SS7 network using the segmentation parameter passed by SUA to SCCP.
SCCP need to be enhanced to support this. I do not see a value being added by
supporting this functionality. So Please disallow ASP to do any segmentation.

--
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---

---

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Fri, 7 Sep 2001 03:40:15 -0500

Sandeep,

[email-masked] wrote:                     (Fri, 07 Sep 2001 13:39:44)
>    does not include the option (except, of course, for the feature the

This does not say that an SG must support the option, it just says
that it must be prepared to interoperate.

> support reassembly. How should SUA at SG should handle these segmented messages?

If the return on error option is set, CLDR("Segmentation Error"), otherwise
discard.

> > further in SS7 network using the segmentation parameter passed by SUA to SCCP.

Then the SG would be supporting receiving segmented CLDT.

> > supporting this functionality.

So don't support it in your implementation.  Return error instead.

> > So Please disallow ASP to do any segmentation.

Just because you don't want to support it is no reason to disallow it.
This case perfectly fits the keyword OPTIONAL.

--brian

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---